From 39efd73252e3cf30e3205cef1d2d27a7aec7b988 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Aug 30 2020 20:24:03 +0000
Subject: [PATCH 770/2232] Add test of cxxbridge cli help text


---

diff --git a/gen/cmd/src/app.rs b/gen/cmd/src/app.rs
index 37934e5..1092dcd 100644
--- a/gen/cmd/src/app.rs
+++ b/gen/cmd/src/app.rs
@@ -1,3 +1,7 @@
+#[cfg(test)]
+#[path = "test.rs"]
+mod test;
+
 use super::Opt;
 use clap::AppSettings;
 use std::ffi::{OsStr, OsString};
diff --git a/gen/cmd/src/test.rs b/gen/cmd/src/test.rs
new file mode 100644
index 0000000..a9f1955
--- /dev/null
+++ b/gen/cmd/src/test.rs
@@ -0,0 +1,45 @@
+const EXPECTED: &str = "\
+cxxbridge 0.3.7
+David Tolnay <dtolnay@gmail.com>
+https://github.com/dtolnay/cxx
+
+USAGE:
+    cxxbridge <input>.rs              Emit .cc file for bridge to stdout
+    cxxbridge <input>.rs --header     Emit .h file for bridge to stdout
+    cxxbridge --header                Emit rust/cxx.h header to stdout
+
+ARGS:
+    <input>
+            Input Rust source file containing #[cxx::bridge].
+
+OPTIONS:
+        --cxx-impl-annotations <annotation>
+            Optional annotation for implementations of C++ function wrappers
+            that may be exposed to Rust. You may for example need to provide
+            __declspec(dllexport) or __attribute__((visibility(\"default\")))
+            if Rust code from one shared object or executable depends on
+            these C++ functions in another.
+                
+    -h, --help
+            Print help information.
+
+        --header
+            Emit header with declarations only.
+
+    -i, --include <include>...
+            Any additional headers to #include. The cxxbridge tool does not
+            parse or even require the given paths to exist; they simply go
+            into the generated C++ code as #include lines.
+                
+    -V, --version
+            Print version information.
+";
+
+#[test]
+fn test_help() {
+    let mut app = super::app();
+    let mut out = Vec::new();
+    app.write_long_help(&mut out).unwrap();
+    let help = String::from_utf8(out).unwrap();
+    assert_eq!(help, EXPECTED);
+}

